

/* HuCARD to PCE image format file converter */

/* <<< HUGET.C >>> Copyright (c) Tanishige   */



#include<stdio.h>

#include<stdlib.h>

#include<fcntl.h>

#include<stat.h>

#include<dos.h>



int mode_sw = 0; /* PC/AT= 0 : PC-98= 1 */



int fhd;

char fname[]="CARD.PCE";

unsigned char head[512],*BUFF;

unsigned char far *ROM;

unsigned int far *p;

unsigned int outport,busyport,strbport,busymask,STBL,STBH;

unsigned long fp,total=0;



void getROM(),makehead();

unsigned long getBLK();



main (){



 unsigned long i;

 

 printf("HuCARD Image Backup Tool [[[ HUGET.EXE ]]] ");



 if (mode_sw) {



  printf(" <<< for PC-98 >>>\n");

  outport  = 0x40;

  strbport = 0x46;

  busyport = 0x42;

  busymask= 0x4; STBL=0xf; STBH=0xe;



 } else {



  printf(" <<< for PC/AT >>>\n");

  p = (unsigned int far *)0x00408;

  outport  = p[0];

  strbport = outport + 2;

  busyport = outport + 1;

  busymask= 0x80; STBL=1; STBH=0;



 }



 printf("PRINTER PORT = %04X \n", outport);

 fhd = open(fname, O_CREAT | O_TRUNC |O_RDWR , S_IWRITE );

 if (!fhd) { printf("FILE OPEN ERROR!!\n"); exit(-1); }



 BUFF = malloc(0x8000);

 if (!BUFF) { printf("MEMORY ALLOCATION ERROR!!\n"); exit(-1); }

 ROM = farmalloc(0x40000);

 if (!ROM) { printf("MEMORY ALLOCATION ERROR!!\n"); exit(-1); }

 for (i=0;i<0x20000;i++) ROM[i]=0;



 getROM(0);

 makehead();



 close(fhd);

 farfree(ROM);

 free(BUFF);

 printf("Complete!!\n");



}



void getROM(){



 char c=1;

 unsigned long i,j,sum;



 outp(strbport,STBL );

 outp(outport,0xff );

 outp(strbport,STBH );

 printf("ROM DUMP:\n");



 total=0x100000;

 

 for (fp=0;fp<total;fp+=0x20000){

  sum = getBLK();

  lseek(fhd,fp+512,SEEK_SET);

  for (i=0;i<0x20000;i+=0x8000){

   for (j=0;j<0x8000;j++) BUFF[j]=ROM[i+j];

   write(fhd,BUFF,0x8000);

  }

  if (fp==0x60000) 

   for (i=0;i<0x20000;i++) ROM[i+0x20000]=ROM[i];

 }

 total=0;

 while (total==0){

  printf("\nSelect ROM Size [1:128k 2:256k 3:384k 4:512k 5:1024k] ");

  c=getch();

  printf("\n");

  switch (c){

   case '1' : total=0x20000; break;

   case '2' : total=0x40000; break;

   case '3' : total=0x60000; break;

   case '4' : total=0x80000; break;

   case '5' : total=0x100000; break;

  }

 }



 if (total==0x60000) {

  lseek(fhd,0x40000+512,SEEK_SET);

  for (i=0x20000;i<0x40000;i+=0x8000){

   for (j=0;j<0x8000;j++) BUFF[j]=ROM[i+j];

   write(fhd,BUFF,0x8000);

  }

 }



 chsize(fhd,total+512);



}



unsigned long getBLK(){

/*

7 #Clk ADD

6  CLK SHF

5  DATA 

4 #SHIFT ENABLE

3  CLR ADD

2 #PRG OE

1 #CHR OE

0 #BOTH WE

*/

 unsigned long i,k=0,sum=0;

 unsigned int j;

 unsigned char c;



 printf("+%04X0 : ",fp>>4);

 

 for (i=0;i<0x20000;i++) {



  outp(strbport,STBL );

  outp(outport,0x17 );

  outp(strbport,STBH );

 

  c=0;

  for (j=0;j<8;j++){

   c = c >> 1;

   outp(strbport,STBL );

   outp(outport,0x67 );

   outp(strbport,STBH );

   outp(strbport,STBL );

   outp(outport,0x27 );

   outp(strbport,STBH );

   if ((inp(busyport)&busymask)==0) c|=0x80;

  }

  

  ROM[i] = c;

  sum = sum + c;



  outp(strbport,STBL );

  outp(outport,0x87 );

  outp(strbport,STBH );

  outp(strbport,STBL );

  outp(outport,0x07 );

  outp(strbport,STBH );



  if ((i&0x1fff)==0) { printf("%02X ",ROM[k]); k++; }



 }

 

 printf(": %05X \n",sum);

 return sum;



}



void makehead(){

 int i;



 for (i=0;i<16;i++) head[i]=0;



 head[0]=(total>>13);

 if (total==0x60000) head[1]=1;



 lseek(fhd,0,SEEK_SET);

 write(fhd,head,512);



 printf("HEAD VIEW:\n 0000 : ");

 for (i=0;i<16;i++) printf("%02X ",head[i]);

 printf("\n");



}



